import java.awt.*;
import java.applet.*;
import java.net.Socket;
import java.net.URL;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;

public class empegApplet extends Applet implements Runnable
{

protected Socket s = null;
protected DataInputStream in = null;
protected DataOutputStream out = null;
protected byte[] img = new byte[2048];
protected int i,j;
protected Color[] colors = new Color[4];
protected int p1,p2;
protected URL MyUrl;
protected int mag,port;
protected String hostname;
protected boolean upd;
protected Thread animThread;
private Image offScreenImage;


	public void init()
	{
	mag= Integer.decode(getParameter("mag")).intValue();
	colors[0]=new Color(Integer.decode(getParameter("color0")).intValue());
	colors[1]=new Color(Integer.decode(getParameter("color1")).intValue());
	colors[2]=new Color(Integer.decode(getParameter("color2")).intValue());
	colors[3]=new Color(Integer.decode(getParameter("color3")).intValue());
	MyUrl=this.getCodeBase();
	hostname=MyUrl.getHost();
	port=MyUrl.getPort();
	}

	public void start()
	{
		// mag=4;
		// colors[0]=new Color(0,0,0);
		// colors[1]=new Color(0,50,0);
		// colors[2]=new Color(0,100,0);
		// colors[3]=new Color(0,255,0);
		offScreenImage=createImage(512,128);
		try {
		s=new Socket(hostname,port);
		in = new DataInputStream(s.getInputStream());
		out = new DataOutputStream(s.getOutputStream());
		}
		catch ( IOException e ) {
			System.out.println(e);
			return;
			}
			System.out.println("ttt3");
		animThread=new Thread(this);
		animThread.start();
	}

	public void stop()
	{
	try {
		s.close();
	} catch ( Exception e ) {
			System.out.println(e);
			}
	s=null;
	in=null;
	out=null;
	}

	public void update(Graphics g)
	{
		Graphics offScreenGraphics=offScreenImage.getGraphics();
		offScreenGraphics.setColor(getBackground());
		offScreenGraphics.fillRect(
			0,0,
			size().width,
			size().height);
		offScreenGraphics.setColor(g.getColor());
		paint(offScreenGraphics);
		g.drawImage(offScreenImage,0,0,this);
	}

	public void run()
	{
			System.out.println("ttt2");
		try {
			out.writeBytes("GET /empeg_stream HTTP/1.0\n\n");
		} catch ( IOException e ) {
			System.out.println("write: "+e);
			return;
		}
		while (true)
		{
                    //thread.sleep(10);
			try {
			in.readFully(img);
			}
			catch ( IOException e ) {
				System.out.println("read: "+e);
				return;
				}
			upd=true;
			repaint();
		}
	}

	public void paint(Graphics g)
	{
	if (upd) {
		for (i=0;i<32;i++)
		{
			for (j=0;j<64;j++)
			{
				p1=(img[(i*64)+j] & 51) >>>4;
				p2=img[(i*64)+j] & 3 ;
				//p2=p2>>>4;
				//System.out.println(
				 //	img[(i*64)+j]+":"+
				 //	p1+":"+
				 //	p2+" "
				 //	);
				
				//System.out.println(
				//j+":"+i+" "+j*2+1+":"+i
				//);
				g.setColor(colors[p2]);
				g.fillRect(j*2*mag,
					i*mag,
					(j*2+1)*mag-1,
					(i+1)*mag-1);
				g.setColor(colors[p1]);
				g.fillRect((j*2+1)*mag,
					i*mag,
					(j*2+2)*mag-1,
					(i+1)*mag-1);
			}
		}
	}
	}
}
